<template>
  <form @submit.prevent="submitForm">
    <div class="form-group" :class="{invalid: !firstname.isValid}">
      <label for="firstname">Prénom</label>
      <input class="form-control" type="text" id="firstname" v-model.trim="firstname.val" @blur="clearValidity('firstname')"/>
      <p v-if="!firstname.isValid">Le prénom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !lastname.isValid}">
      <label for="lastname">Nom</label>
      <input class="form-control" type="text" id="lastname" v-model.trim="lastname.val"  @blur="clearValidity('lastname')"/>
      <p v-if="!lastname.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !username.isValid}">
      <label for="username">Pseudo</label>
      <input class="form-control" type="text" id="username" v-model.trim="username.val" @blur="clearValidity('username')"/>
      <p v-if="!username.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !email.isValid}">
      <label for="email">Email</label>
      <input class="form-control" type="email" id="email" v-model.trim="email.val" @blur="clearValidity('email')"/>
      <p v-if="!email.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !roles.isValid}">
      <label for="roles">roles</label>
      <input class="form-control" type="text" id="roles" v-model.trim="roles.val" @blur="clearValidity('roles')"/>
      <p v-if="!roles.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !roles.isValid}">
      <label for="password">Mot de passe</label>
      <input class="form-control" type="password" id="password" v-model.trim="password.val" @blur="clearValidity('password')"/>
      <p v-if="!roles.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !roles.isValid}">
      <label for="localisation">adresse</label>
      <input class="form-control" type="text" id="localisation" v-model.trim="localisation.val" @blur="clearValidity('localisation')"/>
      <p v-if="!roles.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <base-button>Ajouter</base-button>

  </form>
</template>

<script>
import axios from "axios";

export default {
  emits: ['save-data'],
  data() {
    return {
      firstname: {
        val: '',
        isValid: true,
      },
      lastname: {
        val: '',
        isValid: true,
      },
      username: {
        val: '',
        isValid: true,
      },
      email: {
        val: '',
        isValid: true,
      },
      roles: {
        val: ["ROLE_USER"],
        isValid: true,
      },
      password : {
        val: '',
        isValid: true,
      },
      localisation : {
        val: '',
        isValid: true,
      },
      formIsValid: true,
    };
  },
  methods: {
    clearValidity(input) {
      this[input].isValid = true;
    },
    validateForm() {
      this.formIsValid = true;
      if (this.firstname.val === '') {
        this.firstname.isValid = false;
        this.formIsValid = false;
      }
      if (this.lastname.val === '') {
        this.lastname.isValid = false;
        this.formIsValid = false;
      }
      if (this.username.val === '') {
        this.username.isValid = false;
        this.formIsValid = false;
      }
      if (this.email.val === '') {
        this.email.isValid = false;
        this.formIsValid = false;
      }
    },
    submitForm() {
      this.validateForm();
      console.log(this.formIsValid)
      if (!this.formIsValid) {
        return;
      }

      const formData = {
        firstname : this.firstname.val,
        lastname : this.lastname.val,
        username : this.username.val,
        email : this.email.val,
        roles : this.roles.val,
        password : this.password.val,
        localisation : this.localisation.val,
        isVerified : true,
        status : 0
      }
      try{
        this.$emit('save-data', formData);
      }catch (e) {
        console.log(e)
      }
    },
  },
};
</script>

<style scoped>
</style>